
-- # import Property

-- # import GHC.Base
-- # import GHC.Num
-- # import Data.Tuple-Types
-- # import Data.Tuple-Constructors
-- # import Queue
-- # import Lemmas

Queue : Set -> Set
Queue a = List a

QueueI : Set -> Set
QueueI a = Pair (List a) (List a)

injQueue (a : ISet) : Queue a -> "GHC.Base:[]" a
injQueue = injList

injQueueI (a : ISet) : QueueI a -> "Data.Tuple:(,)" ("GHC.Base:[]" a) ("GHC.Base:[]" a)
injQueueI = injPair injList injList

prop_empty : isTrue "Queue.prop_empty"
prop_empty = cover-plugin(include "Queue", include "GHC.Base", include "GHC.List")


QI = "Data.Tuple:(,)" ("GHC.Base:[]" "GHC.Num:Integer") ("GHC.Base:[]" "GHC.Num:Integer")

--"Queue.prop_isEmpty_0" :
"Queue.prop_isEmpty_0" : (QI -> "GHC.Base:[]" "GHC.Num:Integer") -> QI -> (QI -> "GHC.Base:Bool") ->
			  "GHC.Base::TEq" "GHC.Base:Bool" -> "GHC.Base:Bool"

prop_isEmpty : (q : QueueI "GHC.Num:Integer") ->
		isTrue ("Queue.prop_isEmpty" (injQueueI q))
prop_isEmpty "Pair _|_"	  = assert-plugin()
prop_isEmpty (pair [] []) = cover-plugin( step1
					, step2
					, step3
					)
  where
    emptyI = injQueueI (pair [] [])

    step12 : "Queue.prop_isEmpty" emptyI
		==
	      "GHC.Base.||"
		("GHC.Base.not" ("Queue.invariant" emptyI))
		("GHC.Base.==3"
		    ("Queue.isEmptyI" emptyI)
		    ("GHC.List.null" ("Queue.retrieve" emptyI))
		)
    step12 = cover-plugin( include "Queue", include "GHC.Base"
			 )

    step1 : "Queue.prop_isEmpty" emptyI
	      ==
	     "GHC.Base.||"
		("GHC.Base.not" ("Queue.invariant" emptyI))
		("Queue.prop_isEmpty_0" "Queue.retrieve" emptyI "Queue.isEmptyI"
					"GHC.Base.$fEqBool"
		)
    step1 = cover-plugin(include "Queue")

    step2 : "Queue.prop_isEmpty_0" "Queue.retrieve" emptyI "Queue.isEmptyI"
				    "GHC.Base.$fEqBool"
	      ==
	      "GHC.Base.==3"
		    ("Queue.isEmptyI" emptyI)
		    ("GHC.List.null" ("Queue.retrieve" emptyI))
    step2 = cover-plugin(include "Queue", include "GHC.Base")

    step3 : isTrue (
		    "GHC.Base.||"
		      ("GHC.Base.not" ("Queue.invariant" emptyI))
		      ( "GHC.Base.==3"
			    ("Queue.isEmptyI" emptyI)
			    ("GHC.List.null" ("Queue.retrieve" emptyI))
		      )
		  )
    step3 = cover-plugin( include "GHC.Base"
			, include "Queue"
			, include "GHC.List"
			)
-- 
-- prop_add (a : ISet) : (eqA  : "GHC.Base::TEq" a) ->
-- 			(refl : isReflexiveEq eqA) ->
-- 			(x : a) -> (q : QueueI a) ->
-- 			isTrue ("Queue.prop_add" ("GHC.Base.$fEq[]" eqA) x (injQueueI q))
-- prop_add eqA refl x "Pair _|_" = ?
-- prop_add eqA refl x (pair f b) = ?

