
data Unit = unit

data Nat = zero | suc (n :: Nat)

idata Vec (!A :: Set) :: Nat -> Set where
  nil :: Vec A zero
  cons (|n :: Nat)(x :: A)(xs :: Vec A n) :: Vec A (suc n)

zip (A, B :: Set)(n :: Nat) :: Vec A n -> Vec B n -> Vec (A  B) n
zip xs ys =
  case xs of
  (nil          ) -> nil
  (cons n' x xs') ->
    let F (n :: Nat) :: Vec B n -> Set
        F xs = case n of
               (zero  ) -> Unit
               (suc n0) -> Vec A n0 -> Vec (A  B) (suc n0)
        f (n :: Nat) :: (ys :: Vec B n) -> F ys
        f ys = case ys of
               (nil          ) -> unit
               (cons n0 y ys') -> \xs' -> cons (x,y) (zip xs' ys')
    in  f ys xs'

one   :: Nat = suc zero
two   :: Nat = suc one
three :: Nat = suc two

xs :: Vec Integer (suc (suc (suc zero)))
xs = cons 1 (cons 2 (cons 3 nil))

ys :: Vec Integer (suc (suc (suc zero)))
ys = cons 4 (cons 5 (cons 6 nil))

xys :: Vec (Integer  Integer) (suc (suc (suc zero)))
xys = zip xs ys

main :: Unit
main = {!!}

